CON

' At 80MHz the ADC/DAC sample resolutions and rates are as follows:
'
' sample   sample               
' bits       rate               
' ----------------              
' 5       2.5 MHz               
' 6      1.25 MHz               
' 7       625 KHz               
' 8       313 KHz               
' 9       156 KHz               
' 10       78 KHz               
' 11       39 KHz               
' 12     19.5 KHz               
' 13     9.77 KHz               
' 14     4.88 KHz               
                                
  bits = 8                                              'In this DEMO we are using an 8-Bit ADC
  

PUB start (address)
    cognew(@asm_entry, address)                                 'launch assembly program into a COG

DAT
              org
asm_entry
              mov       dira,asm_dira                   'Set I/O pin states for ADC and Debug LEDs

              movs      ctra,#8 'ADC Input pin
              movd      ctra,#9 'ADC Feedback pin
              movi      ctra,#%01001_000                'POS W/FEEDBACK mode for CTRA
              mov       frqa,#1                         'start CTRA

              mov       asm_cnt,cnt                     'prepare for WAITCNT loop
              add       asm_cnt,asm_cycles
:loop         waitcnt   asm_cnt,asm_cycles              'wait for next CNT value (timing is determinant after WAITCNT)
              mov       new_sample,phsa                 'capture PHSA
              mov       phsa,#0                         'clear PHSA

              sub       new_sample, #149 wc             'set noise trigger threshold
 
        if_c  andn      outa, LEDs                      'clear debug LEDs - quiet
        if_nc or        outa, LEDs                      'set debug LEDs   - noise
        if_nc wrlong    One, par                        'set flag for visual display 
        
              jmp       #:loop                          'wait for next sample period

asm_cycles    long      |< bits - 1                     'sample time for number of bits specified above
asm_dira      long      %00000000_11111111_00000010_00001000                    'I/O mask
LEDs          long      %00000000_11111111_00000000_00001000                    'debug LED mask
One           long      1'
Zero          long      0

asm_cnt       res       1                               'reserved counter variable
new_sample    res       1                               'reserved sample variable


